<!DOCTYPE html>
<html>
  <head>
    <script src="https://aframe.io/releases/1.5.0/aframe.min.js"></script>
  </head>
  <body>
    <a-scene>
      <a-assets>
        <video
          id="BigBuckBunny"
          preload="auto"
          src="https://cdn.aframe.io/videos/bunny.mp4"
          width="160"
          height="90"
          autoplay
          loop="true"
          crossorigin="anonymous"
        ></video>
      </a-assets>
      <!-- i think play-on-click is required since autoplay without interaction is no longer allowed  -->
      <a-videosphere src="#BigBuckBunny" play-on-click></a-videosphere>

      <a-camera>
        <!-- a-camera - items in view always? -->
        <a-entity
          position="0 0 -1.5"
          text="align: center;
                width: 6;
                wrapCount: 100;
                color: black;
                value: Click or tap to start video"
          hide-on-play="#BigBuckBunny"
        >
        </a-entity>
      </a-camera>
    </a-scene>

    <script>
      //https://github.com/aframevr/aframe/blob/master/examples/js/hide-on-play.js
      AFRAME.registerComponent("hide-on-play", {
        schema: { type: "selector" },
        init: function () {
          this.onPlaying = this.onPlaying.bind(this);
          this.onPause = this.onPause.bind(this);
          this.el.object3D.visible = !this.data.playing;
        },
        play: function () {
          if (this.data) {
            this.data.addEventListener("playing", this.onPlaying);
            this.data.addEventListener("pause", this.onPause);
          }
        },
        pause: function () {
          if (this.data) {
            this.data.removeEventListener("playing", this.onPlaying);
            this.data.removeEventListener("pause", this.onPause);
          }
        },
        onPlaying: function (evt) {
          this.el.object3D.visible = false;
        },
        onPause: function (evt) {
          this.el.object3D.visible = true;
        },
      });

      //https://github.com/aframevr/aframe/blob/master/examples/js/play-on-click.js
      AFRAME.registerComponent("play-on-click", {
        init: function () {
          this.onClick = this.onClick.bind(this);
        },
        play: function () {
          window.addEventListener("click", this.onClick);
        },
        pause: function () {
          window.removeEventListener("click", this.onClick);
        },
        onClick: function (evt) {
          var videoEl = this.el.getAttribute("material").src;
          if (!videoEl) {
            return;
          }
          this.el.object3D.visible = true;
          videoEl.play();
        },
      });
    </script>
  </body>
</html>
